标签:hdu 4027 can you ans 线段树
Can you answer these queries?
Time Limit: 4000/2000 MS (Java/Others) Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 9185 Accepted Submission(s): 2100
Problem Description
A lot of battleships of evil are arranged in a line before the battle. Our commander decides to use our secret weapon to eliminate the battleships. Each of the battleships can be marked a value of endurance. For every attack of our secret weapon, it could decrease
the endurance of a consecutive part of battleships by make their endurance to the square root of it original value of endurance. During the series of attack of our secret weapon, the commander wants to evaluate the effect of the weapon, so he asks you for
help.
You are asked to answer the queries that the sum of the endurance of a consecutive part of the battleship line.
Notice that the square root operation should be rounded down to integer.
Input
The input contains several test cases, terminated by EOF.
For each test case, the first line contains a single integer N, denoting there are N battleships of evil in a line. (1 <= N <= 100000)
The second line contains N integers Ei, indicating the endurance value of each battleship from the beginning of the line to the end. You can assume that the sum of all endurance value is less than 263.
The next line contains an integer M, denoting the number of actions and queries. (1 <= M <= 100000)
For the following M lines, each line contains three integers T, X and Y. The T=0 denoting the action of the secret weapon, which will decrease the endurance value of the battleships between the X-th and Y-th battleship, inclusive. The T=1 denoting the query
of the commander which ask for the sum of the endurance value of the battleship between X-th and Y-th, inclusive.
Output
For each test case, print the case number at the first line. Then print one line for each query. And remember follow a blank line after each test case.
Sample Input
10
1 2 3 4 5 6 7 8 9 10
5
0 1 10
1 1 10
1 1 5
0 5 8
1 4 8
Sample Output
Source
Recommend
lcy | We have carefully selected several similar problems for you:
3308 2871 1542 4046 4028
题意:
0 x y: 区间[x,y]所有数更新成原来的开方;
1 x y:求[x,y]所有数的和。
题解:
更新为1之前,暴力更新。区间所有数位1的话,不用更新。
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<string>
#include<algorithm>
#include<cstdlib>
#include<set>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#define N 100010
#define Mod 10000007
#define lson l,mid,idx<<1
#define rson mid+1,r,idx<<1|1
#define lc idx<<1
#define rc idx<<1|1
const double EPS = 1e-11;
const double PI = acos ( -1.0 );
const double E = 2.718281828;
typedef long long ll;
const int INF = 1000010;
using namespace std;
struct node
{
__int64 sum;
int op;//1:区间全为1 0:不全为1
} tree[N<<2];
int n,m;
void push_up(int idx)
{
tree[idx].sum=tree[lc].sum+tree[rc].sum;
tree[idx].op=(tree[lc].op==1&&tree[rc].op==1);
}
void build(int l,int r,int idx)
{
tree[idx].op=0;
if(l==r)
{
scanf("%I64d",&tree[idx].sum);
return;
}
int mid=(l+r)>>1;
build(lson);
build(rson);
push_up(idx);
}
void update(int l,int r,int idx,int x,int y)
{
if(tree[idx].op==1)
return;
if(l==r)
{
tree[idx].sum=sqrt(double(tree[idx].sum));
if(tree[idx].sum==1)
tree[idx].op=1;
return;
}
int mid=(l+r)>>1;
if(x<=mid)
update(lson,x,y);
if(y>mid)
update(rson,x,y);
push_up(idx);
}
__int64 query(int l,int r,int idx,int x,int y)
{
if(x<=l&&r<=y)
return tree[idx].sum;
__int64 ans=0;
int mid=(l+r)>>1;
if(x<=mid)
ans+=query(lson,x,y);
if(y>mid)
ans+=query(rson,x,y);
return ans;
}
int main()
{
//freopen("in.txt","r",stdin);
int ca=1;
while(~scanf("%d",&n))
{
build(1,n,1);
scanf("%d",&m);
printf("Case #%d:\n",ca++);
int x,y,op;
while(m--)
{
scanf("%d%d%d",&op,&x,&y);
if(x>y)
swap(x,y);
if(op)
printf("%I64d\n",query(1,n,1,x,y));
else
update(1,n,1,x,y);
}
printf("\n");
}
return 0;
}
Hdu 4027 Can you answer these queries?(线段树)
标签:hdu 4027 can you ans 线段树
原文地址:http://blog.csdn.net/acm_baihuzi/article/details/43062983